﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Diagram
Imports System.Drawing.Drawing2D
Imports Syncfusion.Windows.Forms.Diagram.Controls

Namespace Sample
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			DiagramAppearance()
			Dim ellipse As New Syncfusion.Windows.Forms.Diagram.Ellipse(10, 10, 100, 100)
			ellipse.Name = "Ellipse"
			ellipse.PropertyBag.Add("value", 10)

			Dim rect As New Syncfusion.Windows.Forms.Diagram.Rectangle(150, 150, 100, 100)
			rect.Name = "Rectangle"
			diagram1.Model.AppendChild(ellipse)
			diagram1.Model.AppendChild(rect)

			Dim con As New OrgLineConnector(New PointF(0, 0), New PointF(100, 100))
			ellipse.CentralPort.TryConnect(con.TailEndPoint)
			rect.CentralPort.TryConnect(con.HeadEndPoint)
			diagram1.Model.AppendChild(con)

			AddHandler diagram1.EventSink.SelectionListChanged, AddressOf EventSink_SelectionListChanged
			AddHandler diagram1.EventSink.NodeCollectionChanged, AddressOf EventSink_NodeCollectionChanged
		End Sub
		Private Sub DiagramAppearance()
			Me.diagram1.View.Grid.Visible = False
			Me.diagram1.Dock = DockStyle.Fill
			Me.diagram1.Model.RenderingStyle.SmoothingMode = SmoothingMode.HighQuality
			Me.diagram1.View.SelectionList.Clear()
		End Sub
		Private Sub EventSink_NodeCollectionChanged(ByVal evtArgs As CollectionExEventArgs)
			If evtArgs.ChangeType = CollectionExChangeType.Insert Then
				If TypeOf evtArgs.Element Is Node AndAlso Not(TypeOf evtArgs.Element Is ConnectorBase) Then
					Dim node As Node = TryCast(evtArgs.Element, Node)
					If node.PropertyBag.Keys.Count > 0 Then
						If node.PropertyBag.ContainsKey("value") Then
							Dim properties As New CommonProperties()
							properties.Value = CSng(node.PropertyBag("value"))
							propertyGrid1.SelectedObject = properties
						End If
					End If
				End If
			Else
				propertyGrid1.SelectedObject = Nothing
			End If
		End Sub

		Private Sub EventSink_SelectionListChanged(ByVal evtArgs As CollectionExEventArgs)
			If evtArgs.ChangeType = CollectionExChangeType.Insert Then
				If TypeOf evtArgs.Element Is Node AndAlso Not(TypeOf evtArgs.Element Is ConnectorBase) Then
					Dim node As Node = TryCast(evtArgs.Element, Node)
					If node.PropertyBag.Keys.Count > 0 AndAlso node.PropertyBag.ContainsKey("value") Then
						Dim properties As New CommonProperties()
						properties.Value = Single.Parse(node.PropertyBag("value").ToString())
						propertyGrid1.SelectedObject = properties
					End If
				End If
			Else
				Dim node As Node = TryCast(evtArgs.Element, Node)
				If TypeOf evtArgs.Element Is Node AndAlso Not(TypeOf evtArgs.Element Is ConnectorBase) AndAlso node.PropertyBag.ContainsKey("value") Then
					node.PropertyBag("value") = (TryCast(propertyGrid1.SelectedObject, CommonProperties)).Value
					propertyGrid1.SelectedObject = Nothing
				End If
			End If
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click
			'passing the values to connected object
			If diagram1.View.SelectionList.Count = 1 Then
				Dim tonode As Node = TryCast(diagram1.View.SelectionList(0), Node)
				If Not(tonode.PropertyBag.ContainsKey("value")) AndAlso Not(TypeOf tonode Is ConnectorBase) Then
					For Each con As ConnectorBase In tonode.EdgesEntering
						Dim fromNode As Node = TryCast(con.FromNode, Node)
						If fromNode.PropertyBag.ContainsKey("value") Then
							tonode.PropertyBag.Add("value", fromNode.PropertyBag("value"))
							fromNode.PropertyBag.Remove("value")
							Dim properties As New CommonProperties()
							properties.Value = Single.Parse(tonode.PropertyBag("value").ToString())
							propertyGrid1.SelectedObject = properties
						End If
					Next con
				End If
			End If
		End Sub
	End Class
End Namespace
